# Written by Mads Engelund, 2017, http://espeem.com
import os
from datetime import datetime
import fnmatch
from os.path import isfile, join
import numpy as np
from CalcTroll.Core.Task import Task, AbstractHasTasks, HasInputs
from CalcTroll.Core.Plugin.Types import AnalysisProvider
from CalcTroll.Core.Analysis.Implementation import Implementation
from CalcTroll.Core.Flags import DEFAULT, MINIMAL, ALL
from CalcTroll.HOSTS import CLUSTERS, DEFAULT_CLUSTER_KEY
from CalcTroll.Core.Utilities import unique
from CalcTroll.Core.Explanation import Explanation
from CalcTroll.Core.Relaxation import AbstractRelaxed

SUBMIT_TYPE_IDENTIFIER = '# Submit type:'


class Workflow:
    def __init__(self, host=DEFAULT):
        self.reset()
        self.setHost(host)

    def reset(self):
        self.__requests = []
        self.__tasks = []

    def __getitem__(self, sl):
        return self.requests()[sl]

    def append(self, item):
        assert not isinstance(item, Task)
        self.__requests.append(item)

    def requests(self):
        return list(self.__requests)

    def setHost(self, host):
        if host is DEFAULT:
            host = CLUSTERS[DEFAULT_CLUSTER_KEY]
        self.__host = host

    def setSubmitType(self, submit_type):
        self.host().setSubmitType(submit_type)

    def submitType(self):
        return self.host().submitType()

    def host(self):
        return self.__host

    def moreToDo(self):
        return any([run.isReady() and not (run.isDone() or run.hasFailed())
                    for run in self.tasks()])

    def isDone(self):
        return all([task.isDone() for task in self.tasks()])

    def updateTasks(self):
        requests = self.requests()
        for request in requests:
            request.updateStatus()

        i = 0
        analyses = list(requests)
        while i < len(analyses):
            an = analyses[i]
            if an.hasInputs():
                analyses.extend(an.inputs())
            i+=1

        analyses = unique(analyses)
        implementers = self.collate(analyses)

        tasks = []
        for imp in implementers:
            tasks.extend(imp.tasks())

        tasks = unique(tasks)
        i = 0
        while len(tasks) > i:
            j = i + 1
            while len(tasks) > j:
                if tasks[i].compatible(tasks[j]):
                    items = tasks[i].items()
                    items.extend(tasks[j].items())
                    items = unique(items)

                    inputs = tasks[i].inputs()
                    inputs.extend(tasks[j].inputs())
                    inputs = unique(inputs)

                    tasks[i] = tasks[i].copy(items=items, inputs=inputs)
                    tasks.pop(j)
                else:
                    j += 1

            i += 1

        self.__tasks = tasks
        self.updateStatus()

        return self.tasks()

    def collate(self, analyses):
        analyses = [an for an in analyses if an.implementation() != None]

        implementations = []
        for an in analyses:
            implementation = an.implementation()
            if not (implementation in implementations):
                implementations.append(implementation)

        new_implementations = []
        for implementation in implementations:
            if implementation == None:
                continue
            imp_ans = [an for an in analyses if an.implementation() == implementation]
            imp_ans = unique(imp_ans)
            new_implementations.append(imp_ans[0].implementation().__class__(items=imp_ans))

        return new_implementations

    def updateStatus(self):
        for task in self.tasks():
            task.updateStatus()

    def tasks(self):
        return self.__tasks

    def explain(self, filename):
        ts = datetime.now().strftime("%B %Y")
        ex = Explanation("The files in this folder were generated by executing the script '%s' on the Espeem server[*]." % filename,
                ['M. Engelund, Espeem STM app, https://app.espeem.com (accessed %s), futher information on https://espeem.com' % ts])
        for request in unique(self.requests()):
            this_ex = request.explain()
            if len(this_ex) > 0:
                ex += this_ex

        described = []
        tasks = list(self.tasks())
        for task in tasks:
            this_ex = task.explain()
            ex += this_ex

        return ex

    def status(self, detail_level=MINIMAL):
        host = self.host()
        done = []
        running = []
        not_ready = []
        ready = []
        queued = []
        failures = []
        for run in self.tasks():
            if run.isDone():
                done.append(run)
            elif not run.isReady():
                not_ready.append(run)
            elif host.isRunning(run):
                running.append(run)
            elif host.isQueued(run):
                queued.append(run)
            elif run.hasFailed():
                failures.append(run)
            else:
                ready.append(run)

        if detail_level == ALL:
            script = writeAllInfo(done=done, not_ready=not_ready, running=running, queued=queued, failures=failures, ready=ready)
        elif detail_level == MINIMAL:
            script = writeMinimalInfo(done=done, not_ready=not_ready, running=running, queued=queued, failures=failures, ready=ready)

        return script

    def cleanUp(self, dry_run=True):
        protect_patterns = dict([(task.runDirectory(), set()) for task in self.tasks()])

        for task in self.tasks():
            protect_patterns[task.runDirectory()].update(task.neededFiles())
            protect_patterns[task.runDirectory()].update(task.resultFiles())

        for path, protect in protect_patterns.items():
            filenames = [f for f in os.listdir(path) if isfile(join(path, f))]
            protected = []
            for pattern in protect:
                protected.extend(fnmatch.filter(filenames, pattern))

            delete = set(filenames) - set(protected)
            for filename in delete:
                filename = os.path.join(path, filename)
                print('remove %s'  % filename)
                if not dry_run:
                    os.remove(filename)


def writeAllInfo(done, not_ready, running, queued, failures, ready):
    script = ''
    script += writeJobInfo('Done', done)
    script += writeJobInfo('Not ready', not_ready)
    script += writeJobInfo('Failed', failures)
    script += writeJobInfo('Running', running)
    script += writeJobInfo('Queued', queued)
    script += writeJobInfo('Ready but not submitted', ready)

    return script

def writeNormalInfo(done, not_ready, running, queued, failures, ready):
        body = ''
        total = 0
        for name, l in [
                ("are done", done),
                ("are running", running),
                ("are queued", queued),
                ("failed", failures),
                ("are ready", ready),
                ("are not ready", not_ready),
                ]:
            total += len(l)
            if len(l) == 1 and name[:3] == 'are':
                name = 'is' + name[3:]
            if len(l) > 0:
                body += '%d %s\n' % (len(l), name)

        script = 'Out of %d tasks:\n' % total
        script += body

        return script

def writeMinimalInfo(done, not_ready, running, queued, failures, ready):
        total = 0
        for l in [done, running, queued, failures, ready, not_ready]:
            total += len(l)

        current = len(done) + 1
        if len(failures) > 0:
            script = 'Script failed on task %d out of %d\n'
        else:
            script = 'Now processing task %d out of %d\n'

        return script % (current, total)


def writeJobInfo(text, run_list):
    if len(run_list) == 0:
        return ''

    script = text + ':\n'
    for run in run_list:
        script += run.runFile() + '\n'

    return script

WORKFLOW = Workflow()
